unit CmdRPNcode;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, FileUtil, Classes, Graphics, Controls, Dialogs, Forms,
  StdCtrls, ExtCtrls;

type

  { TAppForm }
  TAppForm = class(TForm)

    RegBox1: TEdit;

    procedure FormCreate(Sender: TObject);
    procedure RegBox1KeyPress(Sender: TObject; var Key: char);
    procedure RegBox1Change(Sender: TObject);
  private
    { Private declarations }
    procedure UpdDsp;
  public
    { Public declarations }
  end;

var //global variables
  AppForm: TAppForm;

  Reg1: double; // reg0 is for swapping display stack
  Dsp: integer;
  TmpStr: string;

implementation

{$R *.lfm}

procedure TAppForm.FormCreate(Sender: TObject);
begin
  Dsp := 2;
  Reg1 := 0.0;
end;

procedure TAppForm.RegBox1Change(Sender: TObject);
begin
  Str(Reg1: 0: Dsp, TmpStr);
  if TmpStr <> RegBox1.Text then
  begin
    // the above if line causes error when exiting program
  end;
end;


procedure TAppForm.UpdDsp;
begin

  Str(Reg1: 0: Dsp, TmpStr);
  RegBox1.Text := TmpStr;

end;

procedure TAppForm.RegBox1KeyPress(Sender: TObject; var Key: char);
begin
  if (Key in ['0'..'9']) or (key = '.') then  //digit keys
  begin
    RegBox1.Text := RegBox1.Text + Key;
    Key := #0;
  end;
  if Key = #13 then   //enter key
  begin
    Key := #0;
    UpdDsp;
  end;
end;



end.
